case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
    fi
    . ./config.sh
    ;;
esac
: This forces SH files to create target in same directory as SH file.
: This is so that make depend always knows where to find SH derivatives.
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting manicheck (with variable substitutions)"
: This section of the file will have variable substitutions done on it.
: Move anything that needs config subs from !NO!SUBS! section to !GROK!THIS!.
: Protect any dollar signs and backticks that you do not want interpreted
: by putting a backslash in front.  You may delete these comments.
$spitshell >manicheck <<!GROK!THIS!
$startsh
!GROK!THIS!

: In the following dollars and backticks do not need the extra backslash.
$spitshell >>manicheck <<'!NO!SUBS!'
# $Id: manicheck.SH,v 2.11 90/09/17 17:02:57 hokey Exp Locker: hokey $
#
# $Log:	manicheck.SH,v $
# Revision 2.11  90/09/17  17:02:57  hokey
# 2.11 alpha baseline
# 
find . -type f -print | sed -e 's:^./::' | grep -v 'RCS/' | sort > check.present

MF=""
if [ -r MANIFEST ]
then
	MF=MANIFEST
fi

awk '{print $1}' MANIFEST | sort > check.expected

comm -23 check.expected check.present > check.want
comm -13 check.expected check.present > check.extra

rm check.expected check.present

if [ -s check.want ]
then
	echo "There are files missing from this directory."
	echo "See check.want for a list."
else
	rm check.want
fi

if [ -s check.extra ]
then
	echo "There are extra files in this directory."
	echo "See check.extra for a list."
else
	rm check.extra
fi
!NO!SUBS!
chmod a+x manicheck
$eunicefix manicheck
