case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
    fi
    . ./config.sh
    ;;
esac
: This forces SH files to create target in same directory as SH file.
: This is so that make depend always knows where to find SH derivatives.
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting rcsfix (with variable substitutions)"
: This section of the file will have variable substitutions done on it.
: Move anything that needs config subs from !NO!SUBS! section to !GROK!THIS!.
: Protect any dollar signs and backticks that you do not want interpreted
: by putting a backslash in front.  You may delete these comments.
$spitshell >rcsfix <<!GROK!THIS!
#! $perl --	#-*-Perl-*-
        eval "exec $perl -S \$0 \$*"
		if \$running_under_some_shell;
# $Id: rcsfix.SH,v 2.11 90/09/17 17:03:36 hokey Exp Locker: hokey $
#
# $Log:	rcsfix.SH,v $
# Revision 2.11  90/09/17  17:03:36  hokey
# 2.11 alpha baseline
# 
exit 0 if ("$rcs_branch" eq "false");
!GROK!THIS!

: In the following dollars and backticks do not need the extra backslash.
$spitshell >>rcsfix <<'!NO!SUBS!'
chop($WD=`pwd`);
$ENV{'WD'} = $WD;

do 'getopt.pl';
do Getopt("");

do readpackage();

@filelist = ();
if ($opt_a) {
    open(MANI,"MANIFEST") || die "No MANIFEST found.\n";
    while (<MANI>) {
	chop;
	($_) = split(' ');
	push(@filelist,$_);
    }
    close MANI;
}
else {
    push(@filelist,@ARGV);
}

if ($#filelist == -1) {
	print "No files!?\n";
	exit;
}

print "Cleaning branch directives...\n";
do RcsFix('clean',@filelist);
print "Fixing branch directives...\n";
do RcsFix('fix',@filelist);
print "Scanning for obsolete branches...\n";
do RcsFix('scan',@filelist);

!NO!SUBS!
cat ../pl/rcsfix.pl >> rcsfix
cat ../pl/package.pl >> rcsfix
chmod a+x rcsfix
$eunicefix rcsfix
