case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
	echo "Using config.sh from above..."
    fi
    . ./config.sh
    ;;
esac
echo "Extracting makedist (with variable substitutions)"
: This section of the file will have variable substitutions done on it.
: Move anything that needs config subs from !NO!SUBS! section to !GROK!THIS!.
: Protect any dollar signs and backticks that you do not want interpreted
: by putting a backslash in front.
cat >makedist <<!GROK!THIS!
#!$perl --	#-*-Perl-*-
	eval "exec $perl -S \$0 \$*"
		if \$running_under_some_shell;

# $Id: makedist.SH,v 2.11 90/09/17 17:03:49 hokey Exp Locker: hokey $
#
# $Log:	makedist.SH,v $
# Revision 2.11  90/09/17  17:03:49  hokey
# 2.11 alpha baseline
# 
# patch1: depends on perl now
# 
# Revision 2.0  88/06/28  23:12:17  lwall
# Baseline.
# 

\$DIST='`pwd | sed "s#/tmp_mnt##"`';
\$ENV{'DIST'} = \$DIST;
!GROK!THIS!

: In the following dollars and backticks do not need the extra backslash.
$spitshell >>makedist <<'!NO!SUBS!'

do 'getopt.pl';
do Getopt("s");

$MAXKITSIZE = 50000 unless $MAXKITSIZE = $opt_s;
$KITOVERHEAD = 1850;
$FILEOVERHEAD = 90;

$CHOPSIZE = $MAXKITSIZE - $KITOVERHEAD - $FILEOVERHEAD;
$MANI = 'MANIFEST';
$PACK = 'PACKINGLIST';
if (-f 'patchlevel.h') {
    $patchlevel = `cat patchlevel.h`;
    $patchlevel = $1 if $patchlevel =~ /(\d+)/;
    $PACK .= "@$patchlevel" if $patchlevel;
}

do readpackage();

$ENV{'package'} = $package;
$ENV{'baserev'} = $baserev;

unlink <$package.kit? $package.kit??>;

do kitlists();

sub kitlists {
    die "You don't have a $MANI file.  Please create one, with names and descriptions.\n"
	unless -f "$MANI";
    open(IN,$MANI) || die "Can't open $MANI";
    @files = <IN>;
    close IN;
    for $filename (@files) {
	$filename =~ s/(\s.*)?\n//;
	($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,$atime,$mtime,$ctime,
	   $blksize,$blocks) = stat($filename);
	if ($size > $CHOPSIZE) {
	    die "Filename too long to do split: $filename\n"
		if length($filename) > 11;
	    open(FILE, $filename) || die "Can't open $filename: $!\n";
	    $piece = 'AA';
	    open(CURPIECE, ">$filename:$piece") ||
		die "Can't create $filename:$piece: $!\n";
	    $size = 0;
	    while (<FILE>) {
		if ($size + length($_) > $CHOPSIZE) {
		    close CURPIECE;
		    $size{"$filename:$piece"} = $size;
		    $size = 0;
		    $piece++;				# AA -> AB etc.
		    open(CURPIECE, ">$filename:$piece") ||
		      die "Can't create $filename:$piece: $!\n";
		}
		print CURPIECE $_;
		$size += length($_);
	    }
	    close FILE;
	    close CURPIECE;
	    $size{"$filename:$piece"} = $size;
	}
	else {
	    $size += 1000000 if $filename =~ /README/;
	    $size{$filename} = $size;
	}
    }

    sub revnum { $size{$b} - $size{$a}; }
    @files = sort revnum keys(%size);

    for (@files) {
	$size = $size{$_};
	$size -= 1000000 if /README/;
	$i=1;
	while (($newtot = int($tot[$i] + $size + $size/40 + $FILEOVERHEAD)) >
	    $MAXKITSIZE-$KITOVERHEAD && $tot[$i]) {
	      $i++;
	}
	$tot[$i] = $newtot;
	print "Adding $_ to kit $i giving $newtot bytes\n" if $opt_v;
	$kit{$_} = $i;
	$list[$i] .= " $_";
    }
}

do packinglist();

# make PACKINGLIST
sub packinglist {
    open(MANI,$MANI) || die "Can't read $MANI";
    while (<MANI>) {
	($key,$val) = ($_,'') unless ($key,$val) = /^(\S+)\s+(.*)/;
	$comment{$key} = $val;
    }
    close MANI;

    open(PACK,">$PACK") || die "Can't create $PACK.\n";
    print PACK
"After all the $package kits are run you should have the following files:

Filename		Kit Description
--------		--- -----------
";
    for (sort @files) {
	($realname = $_) =~ s/:AA$//;
	printf PACK "%-24s%2s %s\n",$_,$kit{$_},$comment{$realname};
    }
    close PACK;
}

$numkits = $#list;
if ($numkits > 9) {
    $sp = '%02d';
}
else {
    $sp = '%d';
}

for ($kitnum = 1; $kitnum <= $numkits; $kitnum++) {
    $list = $list[$kitnum];
    $kit = sprintf("$package.kit" . $sp,$kitnum);
    print "*** Making $kit ***\n" if $opt_v;
    open(KIT,">$kit") || die "Can't create $kit.\n";

    do kitleader();

    @files = split(' ',$list);
    reset 'X';
    for $file (@files) {
	$file = $PACK if $file eq 'PACKINGLIST';
	$_ = $file;
	while (s|^(.*)/.*$|$1|) {
	    push(@Xdirs,$_) unless $Xseen{$_}++;
	}
    }
    print KIT "mkdir ",join(' ', sort @Xdirs)," 2>/dev/null\n";

    foreach $file (@files) {
	print "\t",$file,"\n" if $opt_v;
	print KIT "echo Extracting $file\n";
	print KIT "sed >$file <<'!STUFFY!FUNK!' -e 's/X//'\n";
	open file;
	while (<file>) {
	    print KIT 'X',$_;
	}
	close file;
	print KIT "!STUFFY!FUNK!\n";
    }
    do kittrailer();
    chmod 0755, $kit;
}
unlink <*:[A-Z][A-Z]>;

sub kitleader {
    print KIT <<"EOLEADER";
#! /bin/sh

# Make a new directory for the $package sources, cd to it, and run kits 1
# thru $numkits through sh.  When all $numkits kits have been run, read README.

echo "This is $package $baserev kit $kitnum (of $numkits).  If kit $kitnum is complete, the line"
echo '"'"End of kit $kitnum (of $numkits)"'" will echo at the end.'
echo ""
export PATH || (echo "You didn't use sh, you clunch." ; kill \$\$)
EOLEADER
}

sub kittrailer {
    $rangelist = '';
    for ($i = 1; $i <= $numkits; $i++) {
	$rangelist .= ' ' . $i;
    }
    print KIT <<"EOTRAILER";
echo " "
echo "End of kit $kitnum (of $numkits)"
cat /dev/null >kit${kitnum}isdone
run=''
config=''
for iskit in$rangelist; do
    if test -f kit\${iskit}isdone; then
	run="\$run \$iskit"
    else
	todo="\$todo \$iskit"
    fi
done
case \$todo in
    '')
	echo "You have run all your kits.  Please read README and then type Configure."
	set *:AA
	if test -f \$1; then
	    for combo in `find . -name '*:AA' -print`; do
		if test -f "\$combo"; then
		    realfile=`echo \$combo | sed 's/:AA//'`
		    cat \$realfile:[A-Z][A-Z] >\$realfile
		    rm -rf \$realfile:[A-Z][A-Z]
		fi
	    done
	fi
	rm -rf kit*isdone
	chmod 755 Configure
	;;
    *)  echo "You have run\$run."
	echo "You still need to run\$todo."
	echo " "
	;;
esac
: Someone might mail this, so...
exit
EOTRAILER
}
!NO!SUBS!
cat ../pl/package.pl >>makedist
chmod +x makedist
$eunicefix makedist
