case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
	echo "Using config.sh from above..."
    fi
    . ./config.sh
    ;;
esac
: This forces SH files to create target in same directory as SH file.
: This is so that make depend always knows where to find SH derivatives.
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting Makefile (with variable substitutions)"
cat >Makefile <<!GROK!THIS!
# $Id: Makefile.SH,v 2.11 90/09/17 17:04:02 hokey Exp Locker: hokey $
#
# $Log:	Makefile.SH,v $
# Revision 2.11  90/09/17  17:04:02  hokey
# 2.11 alpha baseline
# 

bin = $bin
mansrc = $mansrc
manext = $manext

!GROK!THIS!
cat >>Makefile <<'!NO!SUBS!'

public = metaconfig metalint metaxref
private = gloss
manpages = metaconfig.man metalint.man metaxref.man
util = Makefile

c =

obj =

addedbyconf = all $(public)

# grrr
SHELL = /bin/sh

all: $(public) $(private) $(util)
	touch all

metaconfig: metaconfig.SH
	sh metaconfig.SH

metalint: metalint.SH
	sh metalint.SH

metaxref: metaxref.SH
	sh metaxref.SH

gloss:
	chmod +x makegloss
	makegloss

# won't work with csh
install: $(public)
	export PATH || exit 1
	- if test `pwd` != $(bin); then cp $(public) $(bin); fi
	cd $(bin); chmod +x $(public)
	- \
if test `pwd` != $(mansrc); then \
for page in $(manpages); do \
cp $$page $(mansrc)/`basename $$page .man`.$(manext); \
done; \
fi

clean:

realclean:
	rm -f core $(addedbyconf)

!NO!SUBS!
$eunicefix Makefile
