case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
	echo "Using config.sh from above..."
    fi
    . ./config.sh
    ;;
esac
: This forces SH files to create target in same directory as SH file.
: This is so that make depend always knows where to find SH derivatives.
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting metaconfig (with variable substitutions)"
cat >metaconfig <<!GROK!THIS!
#!$perl --	#-*-Perl-*-
        eval "exec $perl -S \$0 \$*"
		if \$running_under_some_shell;

# $Id: metaconfig.SH,v 2.11 90/09/17 17:12:54 hokey Exp Locker: hokey $
#
# $Log:	metaconfig.SH,v $
# Revision 2.11  90/09/17  17:12:54  hokey
# 2.11 alpha baseline
# 

\$MC='`pwd | sed "s#/tmp_mnt##"`';
!GROK!THIS!

: in the following dollars and backticks do not need the extra backslash
$spitshell >>metaconfig <<'!NO!SUBS!'
$ENV{'MC'} = $MC;
chop($WD=`pwd`);
$ENV{'WD'} = $WD;

do 'getopt.pl';
do Getopt("");

++$opt_k if $opt_V;
++$opt_v if $opt_V;
++$opt_x if $opt_X;

unlink 'Obsolete';
unlink 'Wanted' unless $opt_w;

$MANI = 'MANIFEST';

do readpackage();

$ENV{'package'} = $package;

`mkdir .MT 2>&1` unless -d '.MT';

print "Locating units...\n" if $opt_v;
if (-d 'U') {
    chdir 'U' || die "Can't cd to U: $!\n";
    foreach $file (<*.U>) {
	push(@myUlist,"$WD/U/$file");
	$myUseen{$file} = 1;
    }
    chdir '..';
}

chdir "$MC/U" || die "Can't find $MC/U.\n";
foreach $file (<*.U>) {
    if ($myUseen{$file}) {
	print "    Your private U/$file overrides the public one.\n" if $opt_v;
    }
    else {
	push(@ARGV,$file);
    }
}
push(@ARGV,@myUlist);

if ($opt_X) {
    print "\t";
    $, = "\n\t";
    print @ARGV;
    $, = '';
    print "\n";
}

print "Extracting dependency lists from units...\n" if $opt_v;
$dependencies = ' ' x 10000;	# pre-extend
$dependencies = '';
open(INIT,">$WD/.MT/Init.U")      || die "Can't create $WD/.MT/Init.U\n";
open(CONF_H,">$WD/.MT/Config_h.U") || die "Can't create $WD/.MT/Config_h.U\n";
open(OBSOLETE,">$WD/.MT/Obsolete.U") || die "Can't create $WD/.MT/Obsolete.U\n";
line: while (<>) {
    next unless s/^\?//;
    if (s/^MAKE://) {
	if (/^[\w ]*:/) {
	    s|^\s+||;
	    $dependencies .= $_;
	    chop;
	    s/:.*//;
	    @ary = split(' ');
	    $hold = join(' ',@ary);
	    $unit = $ary[0];
	    foreach $sym (@ary) {
		if ($sym =~ /^([a-z]|Mcc|Log|Id|Header)/) {
		    $shmaster{"\$$sym"} = undef;
		    push(@Master,"?$unit:$sym=''\n");
		}
	    }
	}
	else {
	    s/%\*/$hold/;
	    s/%1/$unit/;
	    $dependencies .= $_;
	}
    }
    elsif (/^S:(\w+):/) {
	$new = $1;
    }
    elsif (/^SO:(\w+):/) {
	$shobsolete{"\$$1"} = "\$$new";
    }
    elsif (/^C:/) {
	s|^C:([A-Za-z_][^:]*):|?%1:/* $1| && ( $new = $1 );
	s|^C:\.\s*$|?%1: */\n|;
	s|^C:(.*)|?%1: *$1|;
	s/%\*/$hold/;
	s/%1/$new/ if $new =~ /^LOC_/;
	s/%1/$unit/;
	print CONF_H;
    }
    elsif (/^CO:/) {
	s|^CO:(.*):|?%1:##\$OBSOLETE\t$unit\t$1\t$new|;
	s/%\*/$hold/;
	s/%1/$unit/;
	print OBSOLETE;
    }
    elsif (s/^H://) {
	s/%\*/$hold/;
	s/%1/$unit/;
	print CONF_H;
    }
    elsif (/^L:(.*):/) {
	$cmaster{$1} = undef;
	$cwanted{$1} = $unit;
    }
    elsif (s/^INIT://) {
	s/%\*/$hold/;
	s/%1/$unit/;
	print INIT;
    }
}
print $dependencies if $opt_x;
print CONF_H "#endif\n";
print CONF_H "!GROK!THIS!\n";
close INIT;
close CONF_H;
close OBSOLETE;

chdir $WD;

unless (-f 'Wanted') {
    print "Building a Wanted file...\n" if $opt_v;
    open(WANTED,"| sort | uniq >Wanted") || die "Can't create Wanted.\n";
    die "No $MANI--can't build a Wanted file.\n" unless -f $MANI;

    print "    Extracting filenames (*.[chly] and *.SH) from $MANI...\n"
      if $opt_v;
    open(MANI,$MANI) || die "Can't open $MANI";
    while (<MANI>) {
	($file) = split(' ');
	next if $file eq 'config_h.SH';
	push(@SHlist,$file) if $file =~ /\.SH$/;
	push(@clist,$file) if $file =~ /\.[chly]$/;
    }

    print "    Extracting symbols from Config_h.U...\n" if $opt_v;
    @ARGV = ('.MT/Config_h.U', '.MT/Obsolete.U');
    if (-f 'U/Config_h.U') {
	unshift(@ARGV, 'U/Config_h.U');
    }
    else {
	unshift(@ARGV, "$MC/U/Config_h.U");
    }
    while (<>) {
	print "case-1: _ is $_" if $opt_X;
	next unless /^\?\w*:#.*\$/;
	s|^[^#]*#||;
	print "case 0: _ is $_" if $opt_X;
	if (m|^\$(\w+)\s*(\w+).*\$(\w+).*$|) {
	    print "case 1: cmaster{$2} = undef, cwanted{$2} is $1\\n$3\n" if $opt_x;
	    $cmaster{$2} = undef;
	    $cwanted{$2} = "$1\n$3";
	}
	elsif (m|^\$(\w+)\s*(\w+).*$|) {
	    print "case 2: cmaster{$2} = undef, cwanted{$2} is $1\n" if $opt_x;
	    $cmaster{$2} = undef;
	    $cwanted{$2} = $1;
	}
	elsif (m|^define\s*(\w+).*\$(\w+).*$|) {
	    print "case 3: cmaster{$1} = undef, cwanted{$1} is $2\n" if $opt_x;
	    $cmaster{$1} = undef;
	    $cwanted{$1} = $2;
	}
	elsif (m|^#\$OBSOLETE\s*(\w+)\s(\w+)\s(\w+)$|) {
	    print "case 4: Unit $1, Obsolete form <$2> replaced with <$3>\n" if $opt_x;
	    $omaster{$2} = $3;
	}
	elsif (m|^#\$OBSOLETE\s*(\w+)\s(\w+)$|) {
	    print "case 5: Unit $1, Obsolete form <$2>\n" if $opt_x;
	    $omaster{$2} = '';
	}
	else {
	    print "case 6: Ignoring _ = $_\n" if $opt_X;
	}
    }

    # Now we are a little clever, and build a loop to eval so that we don't
    # have to recompile our patterns on every file.  We also use "study" since
    # we are searching the same string for many different things.  Hauls!

    if (@clist) {
	print "    Scanning *.[chly] files for symbols...\n" if $opt_v;
	$search = ' ' x (40 * @cmaster);
	$search = '';
	$search = "while (<>) {study;\n";	# init loop over ARGV

#	# CRUFT ALERT!  CRUFT ALERT!
#	# We need a "flag" in Wanted, and the search code for grabbing cmaster
#	# uses \w, and I don't want to special case ?L: yet, and this code
#	# wants \b's, and I'd have to special case the qoutes anyways, ...
#	$cmaster{'config.h'} = undef;
#	$cwanted{'config.h'} = 'config_h';
#	if ($opt_V) {
#	    $search .= "if (/\\\"config.h\\\"/) {\$cmaster{'config.h'}++;print \"found config.h\\n\";}\n";
#	}
#	else {
#	    $search .= "\$cmaster{'config.h'}++ if /\\\"config.h\\\"/;\n";
#	}
#	# END CRUFT ALERT!  END CRUFT ALERT!

sub cmaster {
    local($key) = @_;
    $cmaster{$key}++;
    if ($foundhere{$key} ne $ARGV) {
	$visited{$ARGV}++ || print $ARGV,":\n" if $opt_V;
	print "\t$key\n" if $opt_V;
	$foundhere{$key} = $ARGV;
    }
}

sub ofound {
    local($key) = @_;
    $ofound{"$ARGV $key $omaster{$key}"}++;
    if ($foundhere{$key} ne $ARGV) {
	$visited{$ARGV}++ || print $ARGV,":\n" if $opt_V;
	print "\t$key (obsolete)\n" if $opt_V;
	$foundhere{$key} = $ARGV;
    }
}

	foreach $key (keys(cmaster)) {
	    ($pat = $key) =~ s/ /\\s+/g;
	    $search .= "&cmaster('$key') if /\\b$pat\\b/;\n";
	}
	foreach $key (keys(omaster)) {
	    $search .= "&ofound('$key') if /\\b$key\\b/;\n";
	}
	$search .= "}\n";			# terminate loop
	@ARGV = @clist;
	undef $/ unless $opt_m;
	print "search is: $search\n" if $opt_X;
	eval $search;
	eval '';
	%visited = ();
	%foundhere = ();
	$/ = "\n";
	while (($key,$value) = each(cmaster)) {
	    print "\ncmaster($key)=$value" if $opt_x;
	    if (defined $value) {
		print " - WANTED cwanted{$key} ($cwanted{$key})\n" if $opt_V;
		print WANTED $cwanted{$key}, "\n";
	    }
	}
	print "\n" if $opt_V || $opt_x;
	while (($key,$val) = each(%cmaster)) {
	    if ($val && $key =~ /^LOC_/) {
		print WANTED $key,"\n";
	    }
	}
	close WANTED;
    }
    undef %cmaster;
    undef %cwanted;

    if (@SHlist) {
	print "    Scanning *.SH files for symbols...\n" if $opt_v;
	open(WANTED,"| sort | uniq >>Wanted") || die "Can't create Wanted.\n";
	$search = ' ' x (40 * @shmaster);
	$search = '';
	$search = "while (<>) {study;\n";

sub shmaster {
    local($key) = @_;
    $shmaster{$key}++;
    if ($foundhere{$key} ne $ARGV) {
	$visited{$ARGV}++ || print $ARGV,":\n" if $opt_V;
	print "\t$key\n" if $opt_V;
	$foundhere{$key} = $ARGV;
    }
}

sub shofound {
    local($key) = @_;
    $ofound{"$ARGV $key $shobsolete{$key}"}++;
    if ($foundhere{$key} ne $ARGV) {
	$visited{$ARGV}++ || print $ARGV,":\n" if $opt_V;
	print "\t$key (obsolete)\n" if $opt_V;
	$foundhere{$key} = $ARGV;
    }
}

	foreach $key (keys(shmaster)) {
	    $search .= "&shmaster('$key') if /\\$key\\b/;\n";
	}
	foreach $key (keys(shobsolete)) {
	    $search .= "&shofound('$key') if /\\$key\\b/;\n";
	}
	$search .= "}\n";
	@ARGV = @SHlist;
	undef $/ unless $opt_m;
	eval $search;
	undef $search;
	eval '';
	$/ = "\n";
#	    while (<>) {
#		@ary = split(/[^\w\$]+/);
#		for (@ary) {
#		    $shmaster{$_}++ if $shmaster{$_};	# assuming most don't match
#		}
#	    }
	while (($key,$value) = each(shmaster)) {
	    if (defined $value) {
		$key =~ s/^\$//;
		print " - WANTED $key\n" if $opt_V;
		print WANTED $key, "\n";
	    }
	}
	close WANTED;
    }
    undef %shmaster;

    open(OBSOLETE,">Obsolete") || die "Can't create Obsolete.\n";
    print OBSOLETE "File OldSymbol (NewSymbol)\n";
    $oqty = 0;
    foreach $key (sort(keys(ofound))) {
	print OBSOLETE "$key\n";
	++$oqty;
    }
    close OBSOLETE;
    if ($oqty > 0) {
	print " ** Obsolete symbols found - see the 'Obsolete' file for the list.\n";
    }
    else {
	unlink 'Obsolete';
    }
}

die "No desirable symbols found--aborting.\n" unless -s 'Wanted';

print "Building private make file...\n" if $opt_v;
open(WANTED,"Wanted") || die "Can't reopen Wanted.\n";
$W = '';
$I = '';
$want_config_h = 0;
while (<WANTED>) {
    chop;
    if (/^LOC_/) {
	$symwanted{$_}++;
    }
    elsif (/^i_/) {
	$I .= ' '.$_;
    }
    elsif (/^w_config_h$/) {
	$want_config_h = 1;
    }
    else {
	$W .= ' '.$_;
    }
}
close WANTED;

open(MAKEFILE,">.MT/Makefile") || die "Can't create .MT/Makefile.\n";
$W		=~ s/(.{65,}) /$1 \\\n/g;
$I		=~ s/(.{65,}) /$1 \\\n/g;
$dependencies	=~ s/(.{65,}) /$1 \\\n/g;
print MAKEFILE "W =$W\n";
print MAKEFILE "I =$I\n";
print MAKEFILE $dependencies;
close MAKEFILE;

print "Determining the correct order for the units...\n" if $opt_v;
chdir '.MT' || die "Can't chdir to .MT";
open(MAKE, "make -n -f Makefile|") || die "Can't run make";
while (<MAKE>) {
    $_ .= <MAKE> while s/\\\n$//;
    print "\t$_" if $opt_X;
    if (/^[\s\t]*pick/) {
	($pick,$cmd,$symbol,$unit) = split(' ');
	$symwanted{$symbol}++;
	unless ($unitseen{$unit}++) {
	    push(@cmdwanted,"$cmd $unit");
	    $symwanted{$unit}++ unless $unit =~ /^w_/;
	}
    }
    else {
	chop;
	system;
    }
}
close MAKE;

print "Creating Configure...\n" if $opt_v;
open(CONFIGURE,">$WD/Configure") || die "Can't create Configure.\n";
if ($want_config_h) {
    open(CONF_H,">$WD/config_h.SH") || die "Can't create config_h.SH.\n";
}
else {
    `rm -f $WD/config_h.SH 2>&1`;
}
for (@cmdwanted) {
    ($cmd,$unit) = split;
    $dir = ($myUseen{$unit} ? $WD : $MC);
    $unit .= '.U';
    if (m|/|) {
	$file = $unit;			# they must know what they're doing
    }
    elsif ($myUseen{$unit}) {
	$file = "$WD/U/$unit";		# they MIGHT know what they're doing
    }
    else {
	$file = "$MC/U/$unit";		# normal case
    }
    die "Can't open $file" unless open(UNIT,$file);
    print "\t$cmd $file\n" if $opt_X;
    if ($cmd eq 'add') {
	while (<UNIT>) {
	    print CONFIGURE unless /^\?/;
	}
    }
    elsif ($cmd eq 'weed') {
	while (<UNIT>) {
	    if (/^\?(\w+):/) {
		s/^\?\w+:// if $symwanted{$1};
	    }
	    print CONFIGURE unless /^\?/;
	}
    }
    elsif ($cmd eq 'add.package') {
	while (<UNIT>) {
	    s/MCON_PACKAGE/$package/g;
	    s/MCON_BASEREV/$baserev/g;
	    print CONFIGURE unless /^\?/;
	}
    }
    elsif ($cmd eq 'add.Null') {
	for (@Master) {
	    if (/^\?(\w+):/) {
		s/^\?\w+:// if $symwanted{$1};
	    }
	    print CONFIGURE unless /^\?/;
	}
	while (<UNIT>) {
	    print CONFIGURE unless /^\?/;
	}
	print CONFIGURE "CONFIG=''\n";
    }
    elsif ($cmd eq 'add.Config_sh') {
	while (<UNIT>) {
	    last if /^EOT/;
	    print CONFIGURE unless /^\?/;
	}
	for (@Master) {
	    if (/^\?(\w+):/) {
		s/^\?\w+:// if $symwanted{$1};
	    }
	    s/^(\w+)=''/$1='\$$1'/;
	    print CONFIGURE unless /^\?/;
	}
	print CONFIGURE "EOT\n";
	while (<UNIT>) {
	    print CONFIGURE unless /^\?/;
	}
    }
    elsif ($cmd eq 'c_h_weed') {
	while (<UNIT>) {
	    if (/^\?(\w+):/) {
		s/^\?\w+:// if $symwanted{$1};
	    }
	    if ($want_config_h) {
	        print CONF_H unless /^\?/;
	    }
	}
    }
    else {
	die "Unrecognized command from Makefile: $cmd\n";
    }
    close UNIT;
}
close CONFIGURE;
close CONF_H if $want_config_h;

chdir $WD || die "Can't cd back to $WD\n";
`chmod +x Configure`;

open(MANI,$MANI);
undef $/;
$_ = <MANI>;
$/ = "\n";
close MANI;
if (-f 'config_h.SH') {
    unless (/config_h\.SH/) {
	print "Adding config_h.SH to your $MANI file...\n" if $opt_v;
	`echo "config_h.SH	Produces config.h." >>$MANI`;
    }
}
else {
    if (/config_h\.SH/) {
	print "Delete config_h.SH from your $MANI file...\n";
    }
}

if ($opt_k) {
    print "Leaving subdirectory .MT unremoved so you can peruse it.\n";
}
else {
    `rm -rf .MT 2>&1`;
}

print "Done.\n" if $opt_v;

!NO!SUBS!
cat ../pl/package.pl >> metaconfig
chmod +x metaconfig
$eunicefix metaconfig
