case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
	echo "Using config.sh from above..."
    fi
    . ./config.sh
    ;;
esac
: This forces SH files to create target in same directory as SH file.
: This is so that make depend always knows where to find SH derivatives.
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting metalint (with variable substitutions)"
cat >metalint <<!GROK!THIS!
#!$perl --	#-*-Perl-*-
        eval "exec $perl -S \$0 \$*"
		if \$running_under_some_shell;

#$Id: metalint.SH,v 2.11 90/09/17 17:12:58 hokey Exp Locker: hokey $
#
# $Log:	metalint.SH,v $
# Revision 2.11  90/09/17  17:12:58  hokey
# 2.11 alpha baseline
# 

\$MC='`pwd | sed "s#/tmp_mnt##"`';
!GROK!THIS!

: in the following dollars and backticks do not need the extra backslash
$spitshell >>metalint <<'!NO!SUBS!'
$ENV{'MC'} = $MC;
chop($WD=`pwd`);
$ENV{'WD'} = $WD;

do 'getopt.pl';
do Getopt("");

++$opt_v if $opt_V;
++$opt_x if $opt_X;

print "Locating units...\n" if $opt_v;
if (-d 'U') {
    chdir 'U';
    foreach $file (<*.U>) {
	push(@myUlist,"$WD/U/$file");
	$myUseen{$file} = 1;
    }
    chdir '..';
}

chdir "$MC/U" || die "Can't find $MC/U.\n";
@flist = ();
foreach $file (<*.U>) {
    if ($myUseen{$file}) {
	print "    Your private U/$file overrides the public one.\n" if $opt_v;
    }
    else {
	push(@flist,$file);
    }
}

push(@flist,@myUlist);

push(@ARGV,@flist);

if ($opt_X) {
    print "\t";
    $, = "\n\t";
    print @ARGV;
    $, = '';
    print "\n";
}

print "Extracting definition and dependency lists from units...\n" if $opt_v;

$curname = '';
undef %dlist;

$inS = 0;	# in ?S: section
$inC = 0;	# in ?C: section
$o_search = "while(<>) {study;\n";
$o_search .= "print \"\$ARGV done\\n\" if (eof);\n" if $opt_V;

Dline: while (<>) {
    if (eof) {
	if ($inS) {
		print "Missing `?S:.' from end of definition of shell variable $svbl in $unit.U\n";
		$inS = 0;
	}
	if ($inC) {
		print "Missing `?C:.' from end of definition of $cvbl in $unit.U\n";
		$inC = 0;
	}
	# make sure %dlist is empty...
	while (($key,$value) = each %dlist) {
	    if ($value < 1) {
		unless (
		    ($curname eq "AAAAA.U")
		    || (($curname eq $key.'.U') && ($curname =~ /^[A-Z]/))
		    || (($curname eq 'registers.U') && ($key =~ /^reg[0-9]+/))
		   ) {
		    print "$curname claims to MAKE $key, but I don't see where it happens.\n";
		}
	    }
	}
	undef %dlist;
    }
    if ($curname ne $ARGV) {
	$curname = $ARGV;
	print "Starting $curname\n" if $opt_V;
	$inB = 0;	# in `Bottom' part of unit
	$line = 0;
    }
    ++$line;
    if (/^: /) {
	++$inB;
	$search = "{\n";
	while (($key,$value) = each %dlist) {
	    if ($unit eq 'Loc' && !($key eq 'loclist' || $key eq 'trylist')) {
		$search .= "++\$dlist{'$key'} if /^\\?$key:$key\$/;\n";
	    }
	    else {
		$search .= "++\$dlist{'$key'} if /\\b$key=/;\n";
	    }
	}
	$search .= "}\n";
    }
    if ($inB) {
	eval $search;
	next Dline;
    }
    if (/^[^\?]/) {
	print "Missing `: ' line after `?' lines at line $line in $unit.U\n" unless (/^#!/ && ($unit eq 'Head'));
	++$inB;
	next Dline;
    }
    ckT: {
	if (/^(\?RCS)(:?).*/)  { do nocol($1) unless $2; last ckT; }
	if (/^(\?MAKE)(:?).*/) { do nocol($1) unless $2; last ckT; }
	if (/^(\?INIT)(:?).*/) { do nocol($1) unless $2; last ckT; }
	if (/^(\?SO)(:?).*/)   { do nocol($1) unless $2; last ckT; }
	if (/^(\?S)(:?).*/)    { do nocol($1) unless $2; last ckT; }
	if (/^(\?CO)(:?).*/)   { do nocol($1) unless $2; last ckT; }
	if (/^(\?C)(:?).*/)    { do nocol($1) unless $2; last ckT; }
	if (/^(\?H)(:?).*/)    { do nocol($1) unless $2; last ckT; }
	if (/^(\?L)(:?).*/)    { do nocol($1) unless $2; last ckT; }
	if (/^(\?X)(:?).*/)    { do nocol($1) unless $2; last ckT; }
	print "Unrecognized characters after initial `?' at line $line of $unit.U\n";
	next Dline;
    }
    if (/^\?MAKE:\s*(\w+)\s*(.*):\s*(.*)/) {
	$unit = $1;
	$also = $2;
	$wants = $3;

	$sdefs = '';	# Clear shell variable definitions

	if (defined $sdef{$unit}) {
		print "$unit.U wants to define itself, but $sdef{$unit}.U already did so!\n";
	}
	else {
		$sdef{$unit} = "$unit";
	}
	foreach $item (split(' ',$also)) {
		if ($item) {
			if (defined $sdef{$item}) {
				print "$unit.U wants to define $item, but $sdef{$item}.U already did so!\n";
			}
			else {
				$sdef{$item} = "$unit";
			}
		}
	}
	$mdby{$unit} = " $unit $also ";
	print "$unit.U makes: <$mdby{$unit}>\n" if $opt_V;
	$wnt{$unit} = join($",sort(split(' ',$wants)));
	print "$unit.U wants: <$wnt{$unit}>\n" if $opt_V;
	@dlist{split(' ',$mdby{$unit})} = '';
	next Dline;
    }
    if (/^\?S:(\w+)(:?)(.*)/) {
	if ($inS++) {
	    print "Missing `?S:.' from end of definition of shell variable $svbl in $unit.U\n";
	}
	$svbl = $1;
	$colon = $2;
	$extra = $3;
	if ($colon ne ':') {
	    print "Missing `:' from end of definition of shell variable $svbl in $unit.U\n";
	}
	if ($extra ne '') {
	    print "Trailing characters in definition of shell variable $svbl in $unit.U\n";
	}
	print "$unit.U defines shell variable: <$svbl>\n" if $opt_V;
	if (!defined($dlist{$svbl})) {
	    print "$unit.U defines shell variable $svbl, but $svbl isn't on the MAKE line.\n";
	}
	else {
	    ++$dlist{$svbl};
	}
    }
    if (/^\?SO:(\w+)(:?)(.*)/) {
	unless ($inS) {
	    print "Missing `?S:foo:' from beginning of definition of obsolete shell variable $1 in $unit.U\n";
	}
	$sobs = $1;
	$colon = $2;
	$extra = $3;
	if ($colon ne ':') {
	    print "Missing `:' from end of definition of obsolete shell variable $sobs in $unit.U\n";
	}
	if ($extra ne '') {
	    print "Trailing characters in definition of obsolete shell variable $sobs in $unit.U\n";
	}
	print "$unit.U defines obsolete shell variable: <$sobs>\n" if $opt_V;
	if (defined($odef{$sobs})) {
	    print "$unit.U wants to obsolete the shell variable `$sobs', but $odef{$sobs}.U already did so.\n";
	}
	if (defined($sdef{$sobs})) {
	    print "$unit.U wants to obsolete the shell variable `$sobs', but $sdef{$sobs}.U defines it for use.\n";
	}
	$odef{$sobs} = "$unit";
	$osv = '$'.$sobs;
	$nsv = '$'.$svbl;
	$o_search .= "\$ofound{\"\$ARGV \\$osv \\$nsv\"}++ if /\\$osv\\b/;\n";
	$o_search .= "\$ofound{\"\$ARGV $sobs= $svbl=\"}++ if /\\b$sobs\\s\*=/;\n";
    }
    if (/^\?S:\./) {
	if ($inS == 0) {
	    print "Unexpected `?S:.' at line $line of $unit.U\n";
	}
	$inS = 0;
    }
    if (/^\?C:(\w+)(:?)(.*)/) {
	if ($inC++) {
	    print "Missing `?C:.' from end of definition of $cvbl in $unit.U\n";
	}
	$cvbl = $1;
	$colon = $2;
	$extra = $3;
	if ($colon ne ':') {
	    print "Missing `:' from end of definition of $cvbl in $unit.U\n";
	}
	if ($extra ne '') {
	    print "Trailing characters in definition of $cvbl in $unit.U\n";
	}
	print "$unit.U defines C manifest: <$cvbl>\n" if $opt_V;
	if (defined($cdby{$unit})) {
	    $cdby{$unit} .= $cvbl.' ';
	}
	else {
	    $cdby{$unit} = " $cvbl ";
	}
	if (defined($cdef{$cvbl})) {
	    print "$unit.U and $cdef{$cvbl}.U each define the C manifest `$cvbl'.\n";
	}
	else {
	    $cdef{$cvbl} = "$unit";
	}
	# What about obsolete stuff?
    }
    if (/^\?C:\./) {
	if ($inC == 0) {
	    print "Unexpected `?C:.' at line $line of $unit.U\n";
	}
	$inC = 0;
    }
    if (/^\?: /) {
    }
}

print "Scanning units for references to obsolete shell variables...\n" if $opt_v;
$o_search .= "}\n";

@ARGV = @flist;
$/ = "\001";
eval $o_search;
$/ = "\n";

if (defined(%ofound)) {
    print "Obsolete names used:\n";
    print "File\tOld Name\tNew Name\n";
    foreach $key (sort(keys(ofound))) {
	print "$key\n";
    }
}

exit 0;

sub nocol {
    print "Missing `:' after @_ at line $line of $unit.U\n";
}
!NO!SUBS!
chmod +x metalint
$eunicefix metalint
