case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
	echo "Using config.sh from above..."
    fi
    . ./config.sh
    ;;
esac
: This forces SH files to create target in same directory as SH file.
: This is so that make depend always knows where to find SH derivatives.
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting metaxref (with variable substitutions)"
cat >metaxref <<!GROK!THIS!
#!$perl --	#-*-Perl-*-
        eval "exec $perl -S \$0 \$*"
		if \$running_under_some_shell;

# $Id: metaxref.SH,v 2.11 90/09/17 17:13:02 hokey Exp Locker: hokey $
#
# $Log:	metaxref.SH,v $
# Revision 2.11  90/09/17  17:13:02  hokey
# 2.11 alpha baseline
# 
# 

\$MC='`pwd | sed "s#/tmp_mnt##"`';
!GROK!THIS!

: in the following dollars and backticks do not need the extra backslash
$spitshell >>metaxref <<'!NO!SUBS!'
$ENV{'MC'} = $MC;
chop($WD=`pwd`);
$ENV{'WD'} = $WD;

do 'getopt.pl';
do Getopt("");

++$opt_k if $opt_V;
++$opt_v if $opt_V;

$MANI = 'MANIFEST';

`mkdir .MT 2>&1` unless -d '.MT';

print "Locating units...\n" if $opt_v;
if (-d 'U') {
    chdir 'U';
    foreach $file (<*.U>) {
	push(@myUlist,"$WD/U/$file");
	$myUseen{$file} = 1;
    }
    chdir '..';
}

chdir "$MC/U" || die "Can't find $MC/U.\n";
foreach $file (<*.U>) {
    if ($myUseen{$file}) {
	print "    Your private U/$file overrides the public one.\n" if $opt_v;
    }
    else {
	push(@ARGV,$file);
    }
}
push(@ARGV,@myUlist);

print "Extracting dependency lists from units...\n" if $opt_v;
$dependencies = ' ' x 10000;	# pre-extend
$dependencies = '';
open(INIT,">$WD/.MT/Init.U")      || die "Can't create $WD/.MT/Init.U\n";
open(CONF_H,">$WD/.MT/Config_h.U") || die "Can't create $WD/.MT/Config_h.U\n";
open(LOOKFOR,">$WD/.MT/Lookfor.U") || die "Can't create $WD/.MT/Lookfor.U\n";
open(OBSOLETE,">$WD/.MT/Obsolete.U") || die "Can't create $WD/.MT/Obsolete.U\n";
line: while (<>) {
    if (eof) {
	$snam = '';
	$cnam = '';
    }
    if (/^\?MAKE:[\w ]*:/) {
	s|^\?MAKE:\s*||;
	$dependencies .= $_;
	chop;
	s/:.*//;
	@ary = split(' ');
	$hold = join(' ',@ary);
	$unit = $ary[0];
	foreach $sym (@ary) {
	    if ($sym =~ /^([a-z]|Mcc|Log|Id|Header)/) {
		$shmaster{"\$$sym"} = '#';
		$shwanted{"\$$sym"} = "$unit";
		push(@Master,"?$unit:$sym=''\n");
	    }
	}
	next line;
    }
    if (/^\?S:(\w+):/) {
	$snam = $1;
    }
    elsif (/^\?SO:(\w+):/) {
	$shobsolete{"$1"} = "$snam";
	$shwanted{"$1"} = "$unit";
    }
    elsif (/^\?C:/) {
	s|^\?C:([A-Za-z_][^:]*)|?H:?%1:/* $1| && ( $cnam = $1 );
	s|^\?C:\.\s*$|?H:?%1: */\n|;
	s|^\?C:(.*)|?H:?%1: *$1|;
    }
    elsif (/^\?CO:/) {
	s|^\?CO:(.*):|?O:%1:##\$OBSOLETE\t$unit\t$1\t$cnam|;
    }
    elsif (/^\?L:/) {
	s|^\?L:(.*):|?L:?%1:#\$$unit $1|;
    }
    s/%\*/$hold/;
    s/%1/$unit/;
    $dependencies .= $_		if s|^\?MAKE:||;
    print INIT			if s|^\?INIT:||;
    print CONF_H		if s|^\?H:||;
    print LOOKFOR		if s|^\?L:||;
    print OBSOLETE		if s|^\?O:||;
}
print CONF_H "#endif\n";
print CONF_H "!GROK!THIS!\n";
close INIT;
close CONF_H;
close LOOKFOR;
close OBSOLETE;

chdir $WD;

die "No $MANI--don't know who to scan.\n" unless -f $MANI;

print "    Extracting filenames (*.[chly] and *.SH) from $MANI...\n" if $opt_v;
open(MANI,$MANI) || die "Can't open $MANI";
while (<MANI>) {
    ($file) = split(' ');
    next if $file eq 'config.h.SH';
    push(@SHlist,$file) if $file =~ /\.SH$/;
    push(@clist,$file) if $file =~ /\.[chly]$/;
}

print "    Extracting symbols from Config_h.U...\n" if $opt_v;
if (-f 'U/Config_h.U') {
    @ARGV = ('U/Config_h.U', '.MT/Config_h.U', '.MT/Lookfor.U', '.MT/Obsolete.U');
}
else {
    @ARGV = ("$MC/U/Config_h.U", '.MT/Config_h.U', '.MT/Lookfor.U', '.MT/Obsolete.U');
}
while (<>) {
    next unless /^\?\w*:#.*\$/;
    s|^[^#]*#||;
    if (s|^\$(\w+)\s*(\w+).*\$(\w+).*$|$2 $1\n$2 $3|) {
        $cmaster{$2} = '#';
        $cwanted{$2} = "$1\n$3";
    }
    elsif (s|^\$(\w+)\s*(\w+).*$|$2 $1|) {
        $cmaster{$2} = '#';
        $cwanted{$2} = $1;
    }
    elsif (s|^define\s*(\w+).*\$(\w+).*$|$1 $2|) {
        $cmaster{$1} = '#';
        $cwanted{$1} = $2;
    }
    elsif (s|#\$OBSOLETE\s*(\w+)\s*(\w+)\s*(\w+)$||) {
	$omaster{$2} = '#';
	$owanted{$2} = $3;
    }
    elsif (s|#\$OBSOLETE\s*(\w+)\s*(\w+)$||) {
	$omaster{$2} = '#';
	$owanted{$2} = '';
    }
}

open(FUI,"| sort | uniq >I.fui") || die "Can't create I.fui.\n";
open(UIF,"| sort | uniq >I.uif") || die "Can't create I.uif.\n";
open(OBS,"| sort | uniq >I.obs") || die "Can't create I.obs.\n";

# Now we are a little clever, and build a loop to eval so that we don't
# have to recompile our patterns on every file.  We also use "study" since
# we are searching the same string for many different things.  Hauls!

unless ($#clist < 0) {
    print "    Scanning .[chly] files for symbols...\n" if $opt_v;
    $search = "while (<>) {study;\n";	# init loop over ARGV
    foreach $key (keys(cmaster)) {
        $search .= "\$cmaster{'$key'} .= \"\$ARGV#\" if /\\b$key\\b/;\n";
    }
    foreach $key (keys(omaster)) {
        $search .= "\$omaster{'$key'} .= \"\$ARGV#\" if /\\b$key\\b/;\n";
    }
    $search .= "}\n";			# terminate loop
    @ARGV = @clist;
    $/ = "\001" unless $opt_m;
    eval $search;
    $/ = "\n";
    while (($key,$value) = each(cmaster)) {
        if ($value ne '#') {
	    foreach $file (sort(split('#',$value))) {
		if ($file) {
		    print FUI	pack("A20",$file),
				pack("A20","$cwanted{$key}.U"),
				$key,
				"\n";
		    print UIF	pack("A20","$cwanted{$key}.U"),
				pack("A20",$key),
				$file,
				"\n";
		}
	    }
        }
    }
    while (($key,$value) = each(omaster)) {
        if ($value ne '#') {
	    foreach $file (sort(split('#',$value))) {
		if ($file) {
		    print OBS	pack("A20",$file),
				pack("A20","$owanted{$key}.U"),
				$key,
				"\n";
		}
	    }
        }
    }
}

unless ($#SHlist < 0) {
    print "    Scanning .SH files for symbols...\n" if $opt_v;
    $search = "while (<>) {study;\n";
    foreach $key (keys(shmaster)) {
        $search .= "\$shmaster{'$key'} .= \"\$ARGV#\" if /\\$key\\b/;\n";
    }
    foreach $key (keys(shobsolete)) {
        $search .= "\$ofound{'$key'} .= \"\$ARGV#\" if /\\\$$key\\b/;\n";
        $search .= "\$ofound{'$key'} .= \"\$ARGV#\" if /\\b$key\\s*=/;\n";
    }
    $search .= "}\n";
    @ARGV = @SHlist;
    $/ = "\001" unless $opt_m;
    eval $search;
    $/ = "\n";
    while (($key,$value) = each(shmaster)) {
        if ($value ne '#') {
	    foreach $file (sort(split('#',$value))) {
		if ($file) {
		    print FUI	pack("A20",$file),
				pack("A20","$shwanted{$key}.U"),
				$key,
				"\n";
		    print UIF	pack("A20","$shwanted{$key}.U"),
				pack("A20",$key),
				$file,
				"\n";
		}
	    }
        }
    }
    while (($key,$value) = each(ofound)) {
        if ($value ne '#') {
	    foreach $file (sort(split('#',$value))) {
		if ($file) {
		    print OBS	pack("A20",$file),
				pack("A20","$shwanted{$key}.U"),
				$key,
				"\t$shobsolete{$key}",
				"\n";
		}
	    }
        }
    }
}

close FUI;
close UIF;
close OBS;

if ($opt_k) {
    print "Leaving subdirectory .MT unremoved so you can peruse it.\n";
}
else {
    `rm -rf .MT 2>&1`;
}
print "Done.\n" if $opt_v;
!NO!SUBS!
chmod +x metaxref
$eunicefix metaxref
