case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
	echo "Using config.sh from above..."
    fi
    . ./config.sh
    ;;
esac
: This forces SH files to create target in same directory as SH file.
: This is so that make depend always knows where to find SH derivatives.
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting kitsend (with variable substitutions)"
cat >kitsend <<!GROK!THIS!
#!$perl --	#-*-Perl-*-
        eval "exec $perl -S \$0 \$*"
                if \$running_under_some_shell;

# $Id: kitsend.SH,v 2.11 90/09/17 17:13:17 hokey Exp Locker: hokey $
#
# $Log:	kitsend.SH,v $
# Revision 2.11  90/09/17  17:13:17  hokey
# 2.11 alpha baseline
# 

\$orgname='$orgname';
!GROK!THIS!

: In the following dollars and backticks do not need the extra backslash.
cat >>kitsend <<'!NO!SUBS!'

chop($orgname = `cat $orgname`) if $orgname =~ m|^/|;

if (! -f '.package') {
    link('../.package', '.package') || die "Can't find .package\n";
}

do readpackage();

while ($_ = shift) {
    if (/^(kit)?[1-9][\d,-]*$/) {
	s/^kit//;
	push(@argv,$_);
    }
    else {
	push(@dest,$_);
    }
}
$dest = join(' ',@dest);
die "kitsend dest [kits]\n" unless $dest;

@ARGV = @argv;

if (-f "$package.kit10") {
    @filelist = <$package.kit[0-9][0-9]>;
}
else {
    @filelist = <$package.kit[0-9]>;
}
pop(@filelist) =~ /(\d+)$/ && ($maxnum = $1 + 0);

if ($#ARGV < 0) {
    $argv = "1-$maxnum";
    @ARGV = $argv;
}
$argv = do rangeargs(@ARGV);
@ARGV = split(' ',$argv);

$argv =~ s/ $//;

if ($#ARGV < 0) {
    die "No kits specified.\n";
}
elsif ($#ARGV) {
    print "Sending $package $baserev kits $argv to $dest...\n";
}
else {
    print "Sending $package $baserev kit $argv to $dest...\n";
}

fork && exit;

until ($#ARGV < 0) {
    $kitnum = shift;
    open(XHEAD,">.xhead$$") || die "Can't create temp file.\n";
    print XHEAD
"To: $dest
Subject: $package $baserev kit #$kitnum
Organization: $orgname

[There are $maxnum kits for $package version $baserev.]

";
    $kitnum = "0$kitnum" if $kitnum < 10 && $maxnum >= 10;
    open(PATCH,"$package.kit$kitnum") || die "Can't open $package.kit$kitnum\n";
    while (<PATCH>) {
        print XHEAD;
    }
    close XHEAD;
    system "/usr/lib/sendmail -odq -t <.xhead$$";
}
unlink ".xhead$$";

sub rangeargs {
    local($result) = '';
    local($min,$max,$_);
    while ($#_ >= 0) {
	$_ = shift(@_);
	while (/^\s*\d/) {
	    s/^\s*(\d+)//;
	    $min = $1;
	    if (s/^,//) {
		$max = $min;
	    }
	    elsif (s/^-(\d*)//) {
		$max = $1;
		if ($max == 0 && $maxnum) {
		    $max = $maxnum;
		}
		s/^[^,],?//;
	    }
	    else {
		$max = $min;
	    }
	    for ($i = $min; $i <= $max; ++$i) {
		$result .= $i . ' ';
	    }
	}
    }
    $result;
}

!NO!SUBS!
cat ../pl/package.pl >>kitsend
chmod +x kitsend
$eunicefix kitsend
