# -*-Perl-*-
# $Id$
#
# $Log$
sub RcsFix {
    local($op) = shift(@_);
    local(@filelist) = @_;
    local($branch);
    local($total);
    local($revs);
    local($rlog);
    local(@fixlist) = ();
    
    if ($op eq "clean") {
	if ($Debug_RcsFix) {
	    print "rcsfix(): cleaning: ", @filelist;
	}
	else {
	    system 'rcs', '-b', @filelist;
	}
    }
    elsif ($op eq "fix") {
	foreach $file (@filelist) {
	    $branch = '';
	    $total = '';
	    $revs=0;
	    $rlog = `rlog -r$baserev -r$revbranch $file 2>&1`;
	    ($branch) = ($rlog =~ /^branch: (\S+)/);
	    ($total) = ($rlog =~ /total revisions: (\d+)/);
	    ($revs) = ($rlog =~ /selected revisions: (\d+)/);
	    
#    print "File: $file Branch: $branch Total: $total Selected: $revs\n";
	    
	    if ( ( $branch == '' ) && ( $revs > 1 ) ) {
		print "fixing $file, as branch is $branch and selected is $revs.\n" if ($Debug_RcsFix);
		push(@fixlist,$file);
	    }
	    else {
		print "$file is ok: branch is $branch and selected is $revs.\n" if ($Debug_RcsFix);
	    }
	}
	
	system 'rcs', "-b$revbranch", @fixlist unless ($Debug_RcsFix);
    }
    elsif ($op eq "scan") {
	@goodrevs = ( "$baserev", "$revbranch" );
	foreach $file (@filelist) {
	    open(RLOG, "rlog $file|");
	    while(<RLOG>) {
		if (/^revision (\S+)/) {
		    print "$file has unexpected information on $1\n" if (!defined($goodrevs{$1}));
		}
	    }
	    close RLOG;
	}
    }
    else {
	die "rcsfix(): first argument must be {clean,fix,scan}.\n";
    }
}
